from typing import Optional

def check_implements(cls, *meths):
    for meth in meths:
        if hasattr(cls, meth):
            raise ValueError(f"Class already implemented {to}.")


def registerable(_cls: Optional[type] = None, *, meth: str = "register", to: str = "_registereds", dispatch: Optional[str] = None):
    def wrap(cls: type):
        check_implements(cls, meth, to)

        if dispatch:
            check_implements(cls, dispatch)
            setattr(cls, dispatch, (lambda s, i: getattr(s, to).get(i)))

            def wrapper(cls, arg):
                def _wrapper(func):
                    getattr(cls, to)[arg] = func
                    return func

                return _wrapper

        else:

            def wrapper(cls, func): # type: ignore
                getattr(cls, to).append(func)
                return func

        setattr(cls, to, {} if dispatch else [])
        setattr(cls, meth, classmethod(wrapper))
        return cls

    if _cls is None:
        return wrap

    return wrap(_cls)
