import pytest
from clstools.clstools import registerable

@pytest.fixture
def cls():
    return type('A', (), {})

@pytest.fixture
def func():
    def f():
        pass
    return f

def test_registerable_simple(cls, func):
    cls = registerable(cls)
    cls.register(func)
    cls.register(func)
    assert func in cls._registereds
    assert len(cls._registereds) == 2

def test_registerable_with_params(cls, func):
    cls = registerable(to='_xyz')(cls)
    cls.register(func)
    assert not hasattr(cls, '_registereds')
    assert func in cls._xyz

def test_registerable_with_dispatch(cls, func):
    cls = registerable(dispatchable = True)(cls)
    cls.register('a')(func)
    assert cls._registereds.get('a') is func
    inst = cls()
    assert inst.dispatch('a') is func
    assert inst.dispatch('b') is None
